



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>hdu 1811Rank of Tetris (并查集 + 拓扑排序)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">hdu 1811Rank of Tetris (并查集 + 拓扑排序)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 12:33:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums"> /*<br />
     题意：这些信息可能有三种情况，分别是"A &gt; B","A = B","A &lt; B"，分别表示A的Rating高于B,等于B,小于B。

 现在Lele并不是让你来帮他制作这个高手榜，他只是想知道，根据这些信息是否能够确定出这个高手榜，是的话就输出"OK"。<br />
 否则就请你判断出错的原因，到底是因为信息不完全（输出"UNCERTAIN"），还是因为这些信息中包含冲突（输出"CONFLICT"）。<br />
 注意，如果信息中同时包含冲突且信息不完全，就输出"CONFLICT"。

    思路: 因为小于关系和大于关系可以转换一下位置！ 这里的问题就在与如何正确的处理相等的关系！<br />
    如果没有相等的关系，一个拓扑排序算法就可以搞定了！ 既然元素相等，那么我们取相等元素中的某一个<br />
    数来表示每一个数不是也行吗！？对，没错，用这个数来代替所有与之相等元素的数表示 '&lt;'关系！ 也就是<br />
    转换成集合之间的关系的处理！ 将每一个相等的元素集合看成一个点，这个点的代表就是集合的父亲节点！ 

    那么如何来得到这个数呢？并查集最适合不过了！我们将相等的元素放入集合中！<br />
    当 a&lt;b时，通过getFather(a) &lt; getFather(b)来处里a&lt;b的关系，这里用邻接表进行处理！<br />
 */<br />
 #include&lt;iostream&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;vector&gt;<br />
 #include&lt;stack&gt;<br />
 using namespace std;<br />
 int f[];<br />
 int rank[];<br />
 int n, m;<br />
 int getFather(int x){<br />
    return x==f[x] ? x : f[x]=getFather(f[x]);<br />
 }

 int Union(int a, int b){<br />
    int fa=getFather(a), fb=getFather(b);<br />
    if(fa!=fb){<br />
       if(rank[fa]&gt;rank[fb]){<br />
          f[fb]=fa;<br />
          rank[fa]+=rank[fb]+;<br />
       }<br />
       else{<br />
          f[fa]=fb;<br />
          rank[fb]+=rank[fa]+;<br />
       }<br />
       return ;<br />
    }<br />
    return ;<br />
 }

 int in[];<br />
 int A[], B[];<br />
 char ch[];<br />
 vector&lt;int&gt;vx[];<br />
 int conflict, uncertain;<br />
 int sum;

 /*void topoSort(){<br />
     for(int j=1; j&lt;=sum; ++j){<br />
          int p=0, cnt=0;<br />
          for(int i=1; i&lt;=n; ++i)<br />
             if(f[i]==i &amp;&amp; in[i]==0){//f[i]==i表明 i是这个相等集合的代表元素，也就是这个集合所有元素的父节点<br />
                p=i;<br />
                ++cnt;<br />
             }<br />
          if(cnt==0){<br />
             conflict=1;<br />
             return;<br />
          }<br />
          if(cnt&gt;1)<br />
             uncertain=1;<br />
          int len=vx[p].size();<br />
          for(int i=0; i&lt;len; ++i)<br />
              --in[vx[p][i]];<br />
          in[p]=-1;<br />
     }<br />
 }*/

 stack&lt;int&gt;ss;

 void topoSort(){<br />
     for(int i=; i&lt;=n; ++i)<br />
         if(f[i]==i &amp;&amp; in[i]==)//f[i]==i表明 i是这个相等集合的代表元素，也就是这个集合所有元素的父节点<br />
             ss.push(i);<br />
     if(ss.size()== &amp;&amp; sum)<br />
         conflict=;<br />
     while(!ss.empty()){<br />
          int cnt=ss.size();<br />
          int p=ss.top();<br />
          --sum;//表示剩余多少个节点没有排序！<br />
          ss.pop();

          if(cnt&gt;)<br />
             uncertain=;<br />
          int len=vx[p].size();<br />
          for(int i=; i&lt;len; ++i)<br />
              if(--in[vx[p][i]]==)<br />
                ss.push(vx[p][i]);<br />
           if(ss.size()== &amp;&amp; sum)<br />
             conflict=;<br />
     }<br />
 } 

 int main(){<br />
     while(cin&gt;&gt;n&gt;&gt;m){<br />
        for(int i=; i&lt;=n; ++i)<br />
           f[i]=i;<br />
        for(int i=; i&lt;=m; ++i){<br />
            scanf("%d %c %d", &amp;A[i], &amp;ch[i], &amp;B[i]);<br />
            ++A[i];<br />
            ++B[i];<br />
            if(ch[i]=='=')<br />
               Union(A[i], B[i]);<br />
        }<br />
        sum=;<br />
        for(int i=; i&lt;=n; ++i)<br />
           if(f[i]==i)  ++sum;<br />
        for(int i=; i&lt;=m; ++i){<br />
               int fa=getFather(A[i]), fb=getFather(B[i]);//将每一个相等的元素集合看成一个点，这个点的代表就是其父亲节点<br />
            if(ch[i]=='&lt;'){<br />
                vx[fa].push_back(fb);<br />
                ++in[fb];<br />
            }<br />
            else if(ch[i]=='&gt;'){<br />
                vx[fb].push_back(fa);<br />
                ++in[fa];<br />
            }<br />
        }

        conflict=uncertain=;<br />
        topoSort();<br />
        if(conflict)<br />
           cout&lt;&lt;"CONFLICT"&lt;&lt;endl;<br />
        else if(uncertain)<br />
              cout&lt;&lt;"UNCERTAIN"&lt;&lt;endl;<br />
        else cout&lt;&lt;"OK"&lt;&lt;endl;<br />
        for(int i=; i&lt;=n; ++i)<br />
           vx[i].clear();

        memset(rank, , sizeof(int)*(n+));<br />
        memset(in, , sizeof(int)*(n+));<br />
        while(!ss.empty())<br />
           ss.pop();<br />
     }<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rn10mq.html">Oracle Linux 5&period;7安装VMware Tools的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p7dzz9.html">手机safari图片上传竖变横处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8krnp5q.html">数据库连接池之Proxool使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxx6pzq.html">【PowerOJ1740】 圆桌问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlg5d19.html">JS案例之8&mdash;&mdash;从一个数组中随机取数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxny51z8.html">Hive1&period;3 JDBC连接-代码片段</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde14j79.html">【原创】史上最全的Android开发环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oe7l49.html">Objective-C实现变参函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljo2jx9.html">689D Friends and Subsequences RMQ&plus;二分</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j2l3o8.html">NodeJs的简单介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pn4g38.html">&lpar;译&rpar;快速指南：用UIViewPropertyAnimator做动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyywm2gq.html">MySQL【数值处理函数】的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jj5rjq.html">Hadoop学习笔记（五）：java开发MapReduce</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvw62l8.html">C&num; winform 选择文件保存路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvy2lk8.html">013-并发编程-java&period;util&period;concurrent&period;locks之-AbstractQueuedSynchronizer-用于构建锁和同步容器的框架、独占锁与共享锁的获取与释放</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjx6g79.html">update 中实现子查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/953ppxz8.html">Selenium 管理 Cookies</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3n6l9.html">便于理解mysql内幕的各种逻辑图组</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pd1zg8.html">NYOJ 116 士兵杀敌（二）（二叉索引树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9535mx08.html">前端实现table表格导出excel</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q2ggy38.html">&lbrack;Leetcode&rsqb;&lbrack;JAVA&rsqb; Minimum Depth of Binary Tree &amp;amp&semi;&amp;amp&semi; Balanced Binary Tree &amp;amp&semi;&amp;amp&semi; Maximum Depth of Binary Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z662dq.html">Creating a ClickOnce application</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r6m1r9.html">Constructing Roads In JGShining&amp;&num;39&semi;s Kingdom（HDU1025）（LCS序列的变行）</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlw7g08.html">在浏览器的JavaScript里new Date&lpar;&rpar;&period;toUTCString&lpar;&rpar;后，传递给C&num; DateTime&lpar;&rpar;&period;TryParse&lpar;&rpar;会发生什么？</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o3pyp8.html">phoenix 开发API系列 目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z6p51q.html">TypeScript之基本数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy632d8.html">Jexus V5&period;8&period;2 正式发布，强劲的高性能 web 服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r6l3e9.html">SQL SERVER 内存学习系列（二）-DMV查看内存信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r6lre9.html">JQuery源码解析（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96lw749.html">Java设计模式8：迭代器模式</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
